//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Switching LEDs with IR remote

//Look at front of IR receiver (you can see the IR diode)
//Connect left pin of 1838 IR receiver to A0 of Arduino
//Connect middle pin of 1838 IR receiver GND of Arduino
//Connect right pin of 1838 IR receiver +5V of Arduino

//Connect kathode (- short pin, flat side of housing) of LED to GND of Arduino
//Connect anode (+ long pin, round side of housing) to 220 Ohm resistor
//Connect second end of 220 Ohm resistor to pin of Arduino


//Define pin number the LED is connected to
#define LED_R_01_PIN  2
#define LED_R_02_PIN  3
#define LED_R_03_PIN  4
#define LED_R_04_PIN  5

#define LED_Y_01_PIN  6
#define LED_Y_02_PIN  7
#define LED_Y_03_PIN  8
#define LED_Y_04_PIN  9

#define LED_B_01_PIN 10
#define LED_B_02_PIN 11
#define LED_B_03_PIN 12
#define LED_B_04_PIN 13

#define IR_SENSOR_PIN  A0

#define BOUNCE_TIME   0

#define SMALLGAP    120

unsigned long pushPause = 999999;
unsigned long test0 = 0;
unsigned long test1 = 0;
unsigned long test2 = 0;
unsigned long test3 = 0;
unsigned long test4 = 0;
unsigned long test5 = 0;
unsigned long test6 = 0;
unsigned long test7 = 0;
unsigned long test8 = 0;

int oldButtonState = 0;
int newSequence = 0;
int done = 0;


void setup() {                 //This code is executed whenever the board is turned on or the reset button is pressed
  //Switch all LED pins to output mode
  pinMode(LED_R_01_PIN, OUTPUT);
  pinMode(LED_R_02_PIN, OUTPUT);
  pinMode(LED_R_03_PIN, OUTPUT);
  pinMode(LED_R_04_PIN, OUTPUT);

  pinMode(LED_Y_01_PIN, OUTPUT);
  pinMode(LED_Y_02_PIN, OUTPUT);
  pinMode(LED_Y_03_PIN, OUTPUT);
  pinMode(LED_Y_04_PIN, OUTPUT);

  pinMode(LED_B_01_PIN, OUTPUT);
  pinMode(LED_B_02_PIN, OUTPUT);
  pinMode(LED_B_03_PIN, OUTPUT);
  pinMode(LED_B_04_PIN, OUTPUT);

  //Switch sensor pin to input mode
  pinMode(IR_SENSOR_PIN, INPUT_PULLUP);

  pushPause = 999999;
  oldButtonState = 1;
  newSequence = 0;
  done = 0;
  test0 = 0;
  test1 = 0;
  test2 = 0;
  test3 = 0;
  test4 = 0;
  test5 = 0;
  test6 = 0;
  test7 = 0;
  test8 = 0;

  Serial.begin(115200);
//  while (!Serial) {
//    ; // wait for serial port to connect. Needed for native USB port only
//  }
}

void loop() {                       //This loop runs forever

  //Check IR sensor state
  if(digitalRead(IR_SENSOR_PIN)){
    digitalWrite(LED_B_04_PIN, LOW);
    oldButtonState = 1;
  }
  else{
    if(oldButtonState == 1){
      done = 2;
      digitalWrite(LED_B_04_PIN, HIGH);
      pushPause = millis();
      oldButtonState = 0;
      newSequence++;
    }
  }

  if(newSequence == 17){
    test0++;
  }
  if(newSequence == 18){
    test1++;
  }
  if(newSequence == 19){
    test2++;
  }
  if(newSequence == 20){
    test3++;
  }
  if(newSequence == 21){
    test4++;
  }
  if(newSequence == 22){
    test5++;
  }
  if(newSequence == 23){
    test6++;
  }
  if(newSequence == 24){
    test7++;
  }
  if(newSequence == 25){
    test8++;
  }

  //Change sequence if nothing happened for 100ms = 0.1s
  if(millis() - pushPause > 100 && done == 2){
    done = 0;
  }


  if(done == 0){
    newSequence = 0;
    if(test0 > SMALLGAP){
      test0 = 1;
      newSequence += 1;
    }
    else{
      test0 = 0;
    }

    if(test1 > SMALLGAP){
      test1 = 1;
    }
    else{
      test1 = 0;
    }

    if(test2 > SMALLGAP){
      test2 = 1;
      newSequence += 2;
    }
    else{
      test2 = 0;
    }

    if(test3 > SMALLGAP){
      test3 = 1;
      newSequence += 4;
    }
    else{
      test3 = 0;
    }

    if(test4 > SMALLGAP){
      test4 = 1;
      newSequence += 8;
    }
    else{
      test4 = 0;
    }

    if(test5 > SMALLGAP){
      test5 = 1;
      newSequence += 16;
    }
    else{
      test5 = 0;
    }

    if(test6 > SMALLGAP){
      test6 = 1;
      newSequence += 32;
    }
    else{
      test6 = 0;
    }

    if(test7 > SMALLGAP){
      test7 = 1;
      newSequence += 64;
    }
    else{
      test7 = 0;
    }

    if(test8 > SMALLGAP){
      test8 = 1;
      newSequence += 128;
    }
    else{
      test8 = 0;
    }

    Serial.print(test0);
    Serial.print(", ");
    Serial.print(test1);
    Serial.print(", ");
    Serial.print(test2);
    Serial.print(", ");
    Serial.print(test3);
    Serial.print(", ");
    Serial.print(test4);
    Serial.print(", ");
    Serial.print(test5);
    Serial.print(", ");
    Serial.print(test6);
    Serial.print(", ");
    Serial.print(test7);
    Serial.print(", ");
    Serial.print(test8);
    Serial.print(", ");
    Serial.print(newSequence);
    Serial.println(" ");

    test0 = 0;
    test1 = 0;
    test2 = 0;
    test3 = 0;
    test4 = 0;
    test5 = 0;
    test6 = 0;
    test7 = 0;
    test8 = 0;


    //Switch LEDs according to latest push button sequence
    if(newSequence == 23){
      digitalWrite(LED_R_01_PIN, LOW);
      digitalWrite(LED_R_02_PIN, LOW);
      digitalWrite(LED_R_03_PIN, LOW);
      digitalWrite(LED_R_04_PIN, LOW);

      digitalWrite(LED_Y_01_PIN, LOW);
      digitalWrite(LED_Y_02_PIN, LOW);
      digitalWrite(LED_Y_03_PIN, LOW);
      digitalWrite(LED_Y_04_PIN, LOW);

      digitalWrite(LED_B_01_PIN, LOW);
      digitalWrite(LED_B_02_PIN, LOW);
      digitalWrite(LED_B_03_PIN, LOW);
      digitalWrite(LED_B_04_PIN, LOW);
    }
    if(newSequence == 13){
      digitalWrite(LED_R_01_PIN, HIGH);
      digitalWrite(LED_R_02_PIN, HIGH);
      digitalWrite(LED_R_03_PIN, HIGH);
      digitalWrite(LED_R_04_PIN, HIGH);

      digitalWrite(LED_Y_01_PIN, LOW);
      digitalWrite(LED_Y_02_PIN, LOW);
      digitalWrite(LED_Y_03_PIN, LOW);
      digitalWrite(LED_Y_04_PIN, LOW);

      digitalWrite(LED_B_01_PIN, LOW);
      digitalWrite(LED_B_02_PIN, LOW);
      digitalWrite(LED_B_03_PIN, LOW);
      digitalWrite(LED_B_04_PIN, LOW);
    }
    if(newSequence == 25){
      digitalWrite(LED_R_01_PIN, LOW);
      digitalWrite(LED_R_02_PIN, LOW);
      digitalWrite(LED_R_03_PIN, LOW);
      digitalWrite(LED_R_04_PIN, LOW);

      digitalWrite(LED_Y_01_PIN, HIGH);
      digitalWrite(LED_Y_02_PIN, HIGH);
      digitalWrite(LED_Y_03_PIN, HIGH);
      digitalWrite(LED_Y_04_PIN, HIGH);

      digitalWrite(LED_B_01_PIN, LOW);
      digitalWrite(LED_B_02_PIN, LOW);
      digitalWrite(LED_B_03_PIN, LOW);
      digitalWrite(LED_B_04_PIN, LOW);
    }
    if(newSequence == 95){
      digitalWrite(LED_R_01_PIN, HIGH);
      digitalWrite(LED_R_02_PIN, LOW);
      digitalWrite(LED_R_03_PIN, HIGH);
      digitalWrite(LED_R_04_PIN, LOW);

      digitalWrite(LED_Y_01_PIN, HIGH);
      digitalWrite(LED_Y_02_PIN, LOW);
      digitalWrite(LED_Y_03_PIN, HIGH);
      digitalWrite(LED_Y_04_PIN, LOW);

      digitalWrite(LED_B_01_PIN, HIGH);
      digitalWrite(LED_B_02_PIN, LOW);
      digitalWrite(LED_B_03_PIN, HIGH);
      digitalWrite(LED_B_04_PIN, LOW);
    }

    newSequence = 0;
    done = 1;
  }//if(done == 0)


}
