//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Display water level and temperature on LCD display

//Circuit:
//LCD GND to Arduino GND
//LCD VCC to Arduino +5V
//LCD SDA to Arduino A4
//LCD SCL to Arduino A5

//Water level sensor + to Arduino +5V
//Water level sensor - to Arduino GND
//Water level sensor S to Arduino A0

//Temperature sensor LM35DZ (looking on the flat side) left pin to Arduino +5V
//Temperature sensor LM35DZ (looking on the flat side) middle pin to Arduino A1
//Temperature sensor LM35DZ (looking on the flat side) right pin to Arduino GND


#include <Wire.h>
#include <LiquidCrystal_I2C.h>

#define WATER_LEVEL_PIN  A0
#define TEMPERATURE_PIN  A1

int waterLevel;
int temperature;

LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

void setup()
{

  lcd.begin(16,2);               // initialize the lcd

  lcd.home ();                   // go home
  lcd.print("LCD display 2x16");
  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print("0123456789ABCDEF");
  delay ( 10000 );

  lcd.home ();                   // go home
  lcd.print("Water level:    ");
  lcd.setCursor ( 0, 1 );        // go to the next line
  lcd.print ("Temperature:    ");
  delay ( 1000 );
}

void loop(){

  waterLevel = analogRead(WATER_LEVEL_PIN);
  temperature = analogRead(TEMPERATURE_PIN);

  lcd.home ();
  lcd.setCursor ( 12, 0 );
  if(waterLevel < 1000){
    lcd.print (" ");
  }
  if(waterLevel < 100){
    lcd.print (" ");
  }
  if(waterLevel < 10){
    lcd.print (" ");
  }
  lcd.print (waterLevel);

  lcd.setCursor ( 12, 1 );
  if(temperature < 1000){
    lcd.print (" ");
  }
  if(temperature < 100){
    lcd.print (" ");
  }
  if(temperature < 10){
    lcd.print (" ");
  }
  lcd.print (temperature);
   delay (200);
}

