//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Switching LEDs with a push button

//Connect kathode (- short pin, flat side of housing) of LED to GND of Arduino
//Connect anode (+ long pin, round side of housing) to 220 Ohm resistor
//Connect second end of 220 Ohm resistor to pin 2 - 13 of Arduino

//Connect one side of the push button to GND of the Arduino
//Connect the second side of the push button to a 10 kiloohm or 1 kiloohm resistor
//Connect the second side of the resistor to pin A0 of the Arduino

//Define pin number the LED is connected to
#define LED_R_01_PIN  2
#define LED_R_02_PIN  3
#define LED_R_03_PIN  4
#define LED_R_04_PIN  5

#define LED_Y_01_PIN  6
#define LED_Y_02_PIN  7
#define LED_Y_03_PIN  8
#define LED_Y_04_PIN  9

#define LED_B_01_PIN 10
#define LED_B_02_PIN 11
#define LED_B_03_PIN 12
#define LED_B_04_PIN 13

#define PUSH_BUTTON  A0

#define BOUNCE_TIME  200

unsigned long pushPause = 999999;
int oldButtonState = 1;
int oldSequence = 0;
int newSequence = 0;

void setup() {                 //This code is executed whenever the board is turned on or the reset button is pressed
  //Switch all LED pins to output mode
  pinMode(LED_R_01_PIN, OUTPUT);
  pinMode(LED_R_02_PIN, OUTPUT);
  pinMode(LED_R_03_PIN, OUTPUT);
  pinMode(LED_R_04_PIN, OUTPUT);

  pinMode(LED_Y_01_PIN, OUTPUT);
  pinMode(LED_Y_02_PIN, OUTPUT);
  pinMode(LED_Y_03_PIN, OUTPUT);
  pinMode(LED_Y_04_PIN, OUTPUT);

  pinMode(LED_B_01_PIN, OUTPUT);
  pinMode(LED_B_02_PIN, OUTPUT);
  pinMode(LED_B_03_PIN, OUTPUT);
  pinMode(LED_B_04_PIN, OUTPUT);

  //Switch push button pin to input mode
  pinMode(PUSH_BUTTON, INPUT_PULLUP);

  pushPause = 999999;
  oldButtonState = 1;
  oldSequence = 0;
  newSequence = 0;

}

void loop() {                       //This loop runs forever

  //Check push button state
  if(digitalRead(PUSH_BUTTON)){
    digitalWrite(LED_B_04_PIN, LOW);
    oldButtonState = 1;
  }
  else{
    if(millis() - pushPause > BOUNCE_TIME && oldButtonState == 1){
      digitalWrite(LED_B_04_PIN, HIGH);
      pushPause = millis();
      oldButtonState = 0;
      newSequence++;
    }
  }

  //Change sequence if nothing happened for 2000ms = 2s
  if(millis() - pushPause > 2000){
    oldSequence = newSequence;
    newSequence = 0;
  }



  //Switch LEDs according to latest pus button sequence
  if(oldSequence == 1){
    digitalWrite(LED_R_01_PIN, LOW);
    digitalWrite(LED_R_02_PIN, LOW);
    digitalWrite(LED_R_03_PIN, LOW);
    digitalWrite(LED_R_04_PIN, LOW);

    digitalWrite(LED_Y_01_PIN, LOW);
    digitalWrite(LED_Y_02_PIN, LOW);
    digitalWrite(LED_Y_03_PIN, LOW);
    digitalWrite(LED_Y_04_PIN, LOW);

    digitalWrite(LED_B_01_PIN, LOW);
    digitalWrite(LED_B_02_PIN, LOW);
    digitalWrite(LED_B_03_PIN, LOW);
    digitalWrite(LED_B_04_PIN, LOW);
  }
  if(oldSequence == 2){
    digitalWrite(LED_R_01_PIN, HIGH);
    digitalWrite(LED_R_02_PIN, HIGH);
    digitalWrite(LED_R_03_PIN, HIGH);
    digitalWrite(LED_R_04_PIN, HIGH);

    digitalWrite(LED_Y_01_PIN, LOW);
    digitalWrite(LED_Y_02_PIN, LOW);
    digitalWrite(LED_Y_03_PIN, LOW);
    digitalWrite(LED_Y_04_PIN, LOW);

    digitalWrite(LED_B_01_PIN, LOW);
    digitalWrite(LED_B_02_PIN, LOW);
    digitalWrite(LED_B_03_PIN, LOW);
    digitalWrite(LED_B_04_PIN, LOW);
  }
  if(oldSequence == 3){
    digitalWrite(LED_R_01_PIN, LOW);
    digitalWrite(LED_R_02_PIN, LOW);
    digitalWrite(LED_R_03_PIN, LOW);
    digitalWrite(LED_R_04_PIN, LOW);

    digitalWrite(LED_Y_01_PIN, HIGH);
    digitalWrite(LED_Y_02_PIN, HIGH);
    digitalWrite(LED_Y_03_PIN, HIGH);
    digitalWrite(LED_Y_04_PIN, HIGH);

    digitalWrite(LED_B_01_PIN, LOW);
    digitalWrite(LED_B_02_PIN, LOW);
    digitalWrite(LED_B_03_PIN, LOW);
    digitalWrite(LED_B_04_PIN, LOW);
  }
  if(oldSequence == 4){
    digitalWrite(LED_R_01_PIN, HIGH);
    digitalWrite(LED_R_02_PIN, LOW);
    digitalWrite(LED_R_03_PIN, HIGH);
    digitalWrite(LED_R_04_PIN, LOW);

    digitalWrite(LED_Y_01_PIN, HIGH);
    digitalWrite(LED_Y_02_PIN, LOW);
    digitalWrite(LED_Y_03_PIN, HIGH);
    digitalWrite(LED_Y_04_PIN, LOW);

    digitalWrite(LED_B_01_PIN, HIGH);
    digitalWrite(LED_B_02_PIN, LOW);
    digitalWrite(LED_B_03_PIN, HIGH);
    digitalWrite(LED_B_04_PIN, LOW);
  }
  if(oldSequence > 4){
    digitalWrite(LED_R_01_PIN, LOW);
    digitalWrite(LED_R_02_PIN, LOW);
    digitalWrite(LED_R_03_PIN, LOW);
    digitalWrite(LED_R_04_PIN, LOW);

    digitalWrite(LED_Y_01_PIN, LOW);
    digitalWrite(LED_Y_02_PIN, LOW);
    digitalWrite(LED_Y_03_PIN, LOW);
    digitalWrite(LED_Y_04_PIN, LOW);

    digitalWrite(LED_B_01_PIN, LOW);
    digitalWrite(LED_B_02_PIN, LOW);
    digitalWrite(LED_B_03_PIN, LOW);
    digitalWrite(LED_B_04_PIN, LOW);
  }


}
