//http://homofaciens.de/technics-physical-computing-set01_en.htm

//Controlling a servo through a potentiometer
//and changing direction with a pushbutton

//Connect kathode (- brown or black servo cable) to GND of Arduino
//Connect anode (+ red servo cable) to +5V of Arduino
//Connect control line (orange or white cable) to pin 2 of Arduino

//Connect one side of the push button to GND of the Arduino
//Connect the second side of the push button to a 10 kiloohm or 1 kiloohm resistor
//Connect the second side of the resistor to pin 7 of the Arduino

//Potentiometer left pin to Arduino GND
//Potentiometer center pin to Arduino A0
//Potentiometer right pin to Arduino +5V


#include <Servo.h>

#define POTI_PIN      A0
#define SERVO_PIN_01   2
#define PUSH_BUTTON    7

int servoDirection = 0;
int buttonState = 0;

Servo servo01;

int ADCval;    // variable to read the value from the analog pin

void setup() {
  servo01.attach(SERVO_PIN_01);  // attaches the servo on pin 9 to the servo object
  pinMode(PUSH_BUTTON, INPUT_PULLUP);
  pinMode(POTI_PIN, INPUT);
  servoDirection = 0;
  buttonState = 1;

  pinMode(13, OUTPUT);
}

void loop() {
  if(digitalRead(PUSH_BUTTON)){
    digitalWrite(13, HIGH);
    if(buttonState == 0){
      buttonState = 1;
      delay(500);//Wait for contact bounce to finish
    }
  }
  else{
    digitalWrite(13, LOW);
    if(buttonState == 1){
      buttonState = 0;
      if(servoDirection == 0){
        servoDirection = 1;
      }
      else{
        servoDirection = 0;
      }
      delay(500);//Wait for contact bounce to finish
    }
  }
  ADCval = analogRead(POTI_PIN);           // reads the value of the potentiometer (value between 0 and 1023)
  ADCval = map(ADCval, 0, 1023, 0, 180);   // scale it to use it with the servo (value between 0 and 180)
  if(servoDirection == 1){
    ADCval = 180 - ADCval;
  }
  servo01.write(ADCval);
  delay(15);
}

